function err = lpcerror(tstX,tstY,alpha,bias)
%SVCERROR Calculate SVC Error
%
%  Usage: err = svcerror(trnX,trnY,tstX,tstY,ker,alpha,bias)
%
%  Parameters: trnX   - Training inputs
%              trnY   - Training targets
%              tstX   - Test inputs
%              tstY   - Test targets
%              ker    - kernel function
%              beta   - Lagrange Multipliers
%              bias   - bias
%
%  Author: Steve Gunn (srg@ecs.soton.ac.uk)

  if (nargin ~= 4) % check correct number of arguments
    help lpcerror
  else

    m = length(tstY);
    predictedY = sign(tstX*alpha + bias);
    err = sum(predictedY ~= tstY);
  end
