function rlppredict(tstX, tstY, alpha, bias, sigma, outfn, fnames)

fout = fopen(outfn,'w');
fin = fopen(fnames,'r');
%fin = -1;
if (fin < 0)
  usenames = 0;
else
  fclose(fin);
  usenames = 1;
  expnames = textread(fnames,'%s','delimiter','\n','whitespace','');
end
nsig = size(sigma,1) + size(sigma,2) -1;
fprintf('RLPPREDICT nsig = %d\n',nsig);

m = length(tstY);
fprintf('Predicting on %d examples\n',m);
fprintf('YES\n');
if (sum(sigma) > 0)
  pre = (tstX * alpha + bias)/norm(alpha);
  for i = 1:m
    z = pre(i);
%    z = (tstX(i) * alpha + bias)/norm(alpha);
    insideSigmaBall = 0;
    if (nsig > 1.5) 
      sig = sigma(i);
    else
      sig = sigma;
    end
    if (abs(z) <= sig)
      insideSigmaBall = 1;
    end
%fprintf('%d\n',i);
    fprintf(fout,'%d\t',i);
    fprintf(fout,'%d\t%d',sign(z), insideSigmaBall);
    if (usenames > 0) 
      fprintf(fout,'\t:%s:',expnames{i});
    end
    fprintf(fout,'\n');
  end
else
  pre = tstX * alpha + bias;
fprintf('%d\n',length(pre));
  for i = 1:m
    z = pre(i);
%(tstX(i) * alpha + bias);
%fprintf('%d\n',length(z));
    insideSigmaBall = 0;
    fprintf(fout,'%d\t',i);
    fprintf(fout,'%d\t%d',sign(z), insideSigmaBall);
    if (usenames > 0) 
      fprintf(fout,'\t:%s:',expnames{i});
    end
    fprintf(fout,'\n');
  end
end
fclose(fout);


end


