#!/bin/csh -f

# Example method for running ROBUST LIKNON
# from the Unix C-shell.
# this script is set up so that you can loop through a setof
# data files (the 'df' variable), and for each data,
# loop through a set of C values.  For each data, C value,
# matlab is started new, variables set and robust liknon run.
# a log file is saved in a subdirectory "logs".

set p = "b1vb2"

#A loop through the list of data files
foreach df (b1vb2)

#A loop through the C values. typical C is from 0.001 to 10
foreach C ( 0.5 1 5)
echo "STARTING RUN ON DATA FILE " $df ", with cost " $C
set logf="logs/log_"$df"_"$C
matlab -nojvm -nodisplay <<EOF >>$logf
cost = $C
NAMESFILE = 'input/names.txt'
databasename = '$df'
datadir = 'input'
doTEST = 0
testfile = 'input/testdata.dat'
doPREDICT = 0
predictfile = 'input/$p.dat'
predictExpNames = 'input/$p.expnames'
%rhoarray = [0.001 0.005 0.01 0.03 0.05 0.1 0.2 0.3 0.5 0.7 ]
rhoarray = [ .1 .2 ]
doLP = 1
doSOCP = 1
doLOO = 0
sigMethod = 2
RLPS.method = 2
run robustliknon
quit
EOF

end

end



