function err = wlpcerror(tstX,tstY, alpha, bias, RLPS)

% Worst Case Liknon error
% returns a 2 element array of number of worst case errors, and the
% number of errors due to hyperplane intersection.
%    alpha is vector of coefficients

  m = length(tstY);
%fprintf('WLPCERROR m = %d %d %d %d %d %d %d %d\n',m,length(alpha),size(tstX,1),size(tstX,2),size(RLPS.sigma,1),size(RLPS.sigma,2), size(RLPS.sigmaNeg,1), size(RLPS.sigmaNeg,2));
  if (RLPS.sigMethod < 0.5)
    %spherical noise, dimensions are not numgenes, but are number
    %of experiments.
    %compute vector of point to plane distance
%fprintf('here\n');    
    ppd = (tstX * alpha + bias); % just incase of zero / norm(alpha);
    norma = norm(alpha);
    wcerrs = 0;
    planeerrs = 0;
    hwc = 0;

    for i = 1 : m
%fprintf('%d\n',i);    
      hwc = 0;
      % if the point to plane distance is less than the noise radius,
      % then the plane intersects the noise ball, and is a plane error.
      if abs(ppd(i)) <=  (norma * RLPS.sigma(i))
        planeerrs = planeerrs + 1;
        hwc = 1;
      end;
      if(sign(ppd(i)) ~= tstY(i) )
        hwc = 1;
      end;
      wcerrs = wcerrs + hwc;
    end;
%fprintf('wcerrs %d\n',wcerrs);
    err = [wcerrs; planeerrs];
    
  else
% NOTE THAT TECHNICALLY BOTH THESE SHOULD HAVE |alpha| denominators,
% but those will cancel out.
% point to plane distance.
    ppd = (tstX*alpha + bias);
% distance from ellipsoid center that the plane alpha would
% be if it were tangent to ellipsoid (touching at exactly one point).
% if plane is closer (less than) this distance, then it intersects
% the ellipsoid.
    ed = sqrt(alpha' * diag(RLPS.sigma .* RLPS.sigma) * alpha);
    edneg = sqrt(alpha' * diag(RLPS.sigmaNeg .* RLPS.sigmaNeg) * alpha);
fprintf('Tangent plane-ellipsoid distance: %g\n', ed);
%[sr,sc] = size(RLPS.sigma);
%[tr,tc] = size(tstX);
%fprintf('%d %d %d %d %d %g\n',tr,tc,sr,sc,length(alpha),ed);

    wcerrs = 0;
    planeerrs = 0;
    hwc = 0;

    for i = 1 : m
      hwc = 0;
      ddd = ed;
      if (RLPS.sigMethod > 3.5) % & (RLPS.sigMethod < 2.5)
        % is the 2 ball method, so need to choose the proper distance.
        if tstY(i) > 0
          ddd = ed;
        else
          ddd = edneg;
        end;
      end;
%fprintf('%d %g %g\n',i,ppd(i),delta*ed);
      if(abs(ppd(i)) <= ( ddd))
        planeerrs = planeerrs + 1;
        hwc = 1;
      end;
      if(sign(ppd(i)) ~= tstY(i) )
        hwc = 1;
      end;
      wcerrs = wcerrs + hwc;
    end;
%fprintf('wcerrs %d\n',wcerrs);
    err = [wcerrs; planeerrs];
     
  end
